# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictStr, field_validator
from typing import Optional
from typing_extensions import Annotated
from scc_firewall_manager_sdk.models.device_metrics_response import DeviceMetricsResponse

from scc_firewall_manager_sdk.api_client import ApiClient, RequestSerialized
from scc_firewall_manager_sdk.api_response import ApiResponse
from scc_firewall_manager_sdk.rest import RESTResponseType


class DeviceHealthApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def get_asa_health_metrics(
        self,
        start: Annotated[Optional[StrictStr], Field(description="Start of the time range (ISO 8601 format)")] = None,
        end: Annotated[Optional[StrictStr], Field(description="End of the time range (ISO 8601 format)")] = None,
        time_range: Annotated[Optional[StrictStr], Field(description="Relative time range (mutually exclusive with start/end)")] = None,
        limit: Annotated[Optional[Annotated[str, Field(strict=True)]], Field(description="Maximum number of device records to return (used only when no deviceUids are provided)")] = None,
        offset: Annotated[Optional[Annotated[str, Field(strict=True)]], Field(description="Offset for pagination (used only when no deviceUids are provided)")] = None,
        device_uids: Annotated[Optional[Annotated[str, Field(min_length=0, strict=True, max_length=50)]], Field(description="Comma-separated list of device UIDs to query. Max 50. If omitted, results are paginated.")] = None,
        metrics: Annotated[Optional[StrictStr], Field(description="Comma-separated list of metrics to return (e.g. cpu, mem). Returns all if omitted.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> DeviceMetricsResponse:
        """Get time-series health metrics for one or more ASA devices

        Returns time-series metrics such as CPU, memory, disk, connections, and environment data over a specified time range. Supports filtering by device and metric. Pagination applies only when device UIDs are not specified.

        :param start: Start of the time range (ISO 8601 format)
        :type start: str
        :param end: End of the time range (ISO 8601 format)
        :type end: str
        :param time_range: Relative time range (mutually exclusive with start/end)
        :type time_range: str
        :param limit: Maximum number of device records to return (used only when no deviceUids are provided)
        :type limit: str
        :param offset: Offset for pagination (used only when no deviceUids are provided)
        :type offset: str
        :param device_uids: Comma-separated list of device UIDs to query. Max 50. If omitted, results are paginated.
        :type device_uids: str
        :param metrics: Comma-separated list of metrics to return (e.g. cpu, mem). Returns all if omitted.
        :type metrics: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_asa_health_metrics_serialize(
            start=start,
            end=end,
            time_range=time_range,
            limit=limit,
            offset=offset,
            device_uids=device_uids,
            metrics=metrics,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DeviceMetricsResponse",
            '400': "CommonApiError",
            '401': "AuthenticationError",
            '403': "CommonApiError",
            '404': "CommonApiError",
            '500': "CommonApiError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def get_asa_health_metrics_with_http_info(
        self,
        start: Annotated[Optional[StrictStr], Field(description="Start of the time range (ISO 8601 format)")] = None,
        end: Annotated[Optional[StrictStr], Field(description="End of the time range (ISO 8601 format)")] = None,
        time_range: Annotated[Optional[StrictStr], Field(description="Relative time range (mutually exclusive with start/end)")] = None,
        limit: Annotated[Optional[Annotated[str, Field(strict=True)]], Field(description="Maximum number of device records to return (used only when no deviceUids are provided)")] = None,
        offset: Annotated[Optional[Annotated[str, Field(strict=True)]], Field(description="Offset for pagination (used only when no deviceUids are provided)")] = None,
        device_uids: Annotated[Optional[Annotated[str, Field(min_length=0, strict=True, max_length=50)]], Field(description="Comma-separated list of device UIDs to query. Max 50. If omitted, results are paginated.")] = None,
        metrics: Annotated[Optional[StrictStr], Field(description="Comma-separated list of metrics to return (e.g. cpu, mem). Returns all if omitted.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[DeviceMetricsResponse]:
        """Get time-series health metrics for one or more ASA devices

        Returns time-series metrics such as CPU, memory, disk, connections, and environment data over a specified time range. Supports filtering by device and metric. Pagination applies only when device UIDs are not specified.

        :param start: Start of the time range (ISO 8601 format)
        :type start: str
        :param end: End of the time range (ISO 8601 format)
        :type end: str
        :param time_range: Relative time range (mutually exclusive with start/end)
        :type time_range: str
        :param limit: Maximum number of device records to return (used only when no deviceUids are provided)
        :type limit: str
        :param offset: Offset for pagination (used only when no deviceUids are provided)
        :type offset: str
        :param device_uids: Comma-separated list of device UIDs to query. Max 50. If omitted, results are paginated.
        :type device_uids: str
        :param metrics: Comma-separated list of metrics to return (e.g. cpu, mem). Returns all if omitted.
        :type metrics: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_asa_health_metrics_serialize(
            start=start,
            end=end,
            time_range=time_range,
            limit=limit,
            offset=offset,
            device_uids=device_uids,
            metrics=metrics,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DeviceMetricsResponse",
            '400': "CommonApiError",
            '401': "AuthenticationError",
            '403': "CommonApiError",
            '404': "CommonApiError",
            '500': "CommonApiError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def get_asa_health_metrics_without_preload_content(
        self,
        start: Annotated[Optional[StrictStr], Field(description="Start of the time range (ISO 8601 format)")] = None,
        end: Annotated[Optional[StrictStr], Field(description="End of the time range (ISO 8601 format)")] = None,
        time_range: Annotated[Optional[StrictStr], Field(description="Relative time range (mutually exclusive with start/end)")] = None,
        limit: Annotated[Optional[Annotated[str, Field(strict=True)]], Field(description="Maximum number of device records to return (used only when no deviceUids are provided)")] = None,
        offset: Annotated[Optional[Annotated[str, Field(strict=True)]], Field(description="Offset for pagination (used only when no deviceUids are provided)")] = None,
        device_uids: Annotated[Optional[Annotated[str, Field(min_length=0, strict=True, max_length=50)]], Field(description="Comma-separated list of device UIDs to query. Max 50. If omitted, results are paginated.")] = None,
        metrics: Annotated[Optional[StrictStr], Field(description="Comma-separated list of metrics to return (e.g. cpu, mem). Returns all if omitted.")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Get time-series health metrics for one or more ASA devices

        Returns time-series metrics such as CPU, memory, disk, connections, and environment data over a specified time range. Supports filtering by device and metric. Pagination applies only when device UIDs are not specified.

        :param start: Start of the time range (ISO 8601 format)
        :type start: str
        :param end: End of the time range (ISO 8601 format)
        :type end: str
        :param time_range: Relative time range (mutually exclusive with start/end)
        :type time_range: str
        :param limit: Maximum number of device records to return (used only when no deviceUids are provided)
        :type limit: str
        :param offset: Offset for pagination (used only when no deviceUids are provided)
        :type offset: str
        :param device_uids: Comma-separated list of device UIDs to query. Max 50. If omitted, results are paginated.
        :type device_uids: str
        :param metrics: Comma-separated list of metrics to return (e.g. cpu, mem). Returns all if omitted.
        :type metrics: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_asa_health_metrics_serialize(
            start=start,
            end=end,
            time_range=time_range,
            limit=limit,
            offset=offset,
            device_uids=device_uids,
            metrics=metrics,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "DeviceMetricsResponse",
            '400': "CommonApiError",
            '401': "AuthenticationError",
            '403': "CommonApiError",
            '404': "CommonApiError",
            '500': "CommonApiError",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _get_asa_health_metrics_serialize(
        self,
        start,
        end,
        time_range,
        limit,
        offset,
        device_uids,
        metrics,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[str, str] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if start is not None:
            
            _query_params.append(('start', start))
            
        if end is not None:
            
            _query_params.append(('end', end))
            
        if time_range is not None:
            
            _query_params.append(('timeRange', time_range))
            
        if limit is not None:
            
            _query_params.append(('limit', limit))
            
        if offset is not None:
            
            _query_params.append(('offset', offset))
            
        if device_uids is not None:
            
            _query_params.append(('deviceUids', device_uids))
            
        if metrics is not None:
            
            _query_params.append(('metrics', metrics))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            [
                'application/json'
            ]
        )


        # authentication setting
        _auth_settings: List[str] = [
            'bearerAuth'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/v1/inventory/devices/asas/health/metrics',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


